#' @importFrom basilisk BasiliskEnvironment

## List of packages exported from working environment
## - pinned versions were obtained from
## https://github.com/csoneson/sketchR_package_list
## - we are currently not setting dependencies on
## basilisk.utils::isLinuxAarch64()
if (basilisk.utils::isLinux()) {
    .sketchR_dependencies <- c(
        "_libgcc_mutex==0.1",
        "_openmp_mutex==4.5",
        "anndata==0.10.5.post1",
        "array-api-compat==1.4.1",
        "blosc==1.21.5",
        "bottleneck==1.3.7",
        "brotli==1.1.0",
        "brotli-bin==1.1.0",
        "bzip2==1.0.8",
        "c-ares==1.26.0",
        "ca-certificates==2023.11.17",
        "cached-property==1.5.2",
        "cached_property==1.5.2",
        "certifi==2023.11.17",
        "colorama==0.4.6",
        "contourpy==1.2.0",
        "curl==8.5.0",
        "cycler==0.12.1",
        "dunamai==1.19.0",
        "exceptiongroup==1.2.0",
        "fonttools==4.47.2",
        "freetype==2.12.1",
        "get_version==3.5.5",
        "gettext==0.21.1",
        "git==2.43.0",
        "h5py==3.8.0",
        "hdf5==1.14.0",
        "icu==73.2",
        "importlib-metadata==7.0.1",
        "importlib_metadata==7.0.1",
        "joblib==1.1.0",
        "jpeg==9e",
        "keyutils==1.6.1",
        "kiwisolver==1.4.5",
        "krb5==1.21.2",
        "lcms2==2.12",
        "ld_impl_linux-64==2.40",
        "legacy-api-wrap==1.2",
        "lerc==3.0",
        "libaec==1.1.2",
        "libblas==3.9.0",
        "libbrotlicommon==1.1.0",
        "libbrotlidec==1.1.0",
        "libbrotlienc==1.1.0",
        "libcblas==3.9.0",
        "libcurl==8.5.0",
        "libdeflate==1.10",
        "libedit==3.1.20191231",
        "libev==4.33",
        "libexpat==2.5.0",
        "libffi==3.4.2",
        "libgcc-ng==13.2.0",
        "libgfortran-ng==13.2.0",
        "libgfortran5==13.2.0",
        "libgomp==13.2.0",
        "libhwloc==2.9.3",
        "libiconv==1.17",
        "liblapack==3.9.0",
        "libllvm14==14.0.6",
        "libnghttp2==1.58.0",
        "libnsl==2.0.1",
        "libopenblas==0.3.25",
        "libpng==1.6.42",
        "libsqlite==3.44.2",
        "libssh2==1.11.0",
        "libstdcxx-ng==13.2.0",
        "libtiff==4.3.0",
        "libuuid==2.38.1",
        "libwebp-base==1.3.2",
        "libxcrypt==4.4.36",
        "libxml2==2.12.4",
        "libzlib==1.2.13",
        "llvmlite==0.40.1",
        "lz4-c==1.9.4",
        "lzo==2.10",
        "matplotlib-base==3.6.3",
        "munkres==1.0.7",
        "natsort==8.4.0",
        "ncurses==6.4",
        "networkx==3.2",
        "nomkl==1.0",
        "numba==0.57.1",
        "numexpr==2.8.3",
        "numpy==1.21.5",
        "olefile==0.47",
        "openjpeg==2.5.0",
        "openssl==3.2.1",
        "packaging==23.2",
        "pandas==1.3.5",
        "patsy==0.5.6",
        "pcre2==10.42",
        "perl==5.32.1",
        "pillow==8.4.0",
        "pip==23.3.2",
        "pynndescent==0.5.11",
        "pyparsing==3.1.1",
        "pytables==3.7.0",
        "python==3.9.12",
        "python-dateutil==2.8.2",
        "python_abi==3.9",
        "pytz==2023.4",
        "readline==8.2",
        "scanpy==1.7.2",
        "scikit-learn==1.0.2",
        "scipy==1.7.3",
        "seaborn==0.13.2",
        "seaborn-base==0.13.2",
        "setuptools==69.0.3",
        "setuptools-scm==8.0.4",
        "setuptools_scm==8.0.4",
        "sinfo==0.3.1",
        "six==1.16.0",
        "snappy==1.1.10",
        "sqlite==3.44.2",
        "statsmodels==0.13.5",
        "stdlib-list==0.10.0",
        "tbb==2021.11.0",
        "threadpoolctl==3.0.0",
        "tk==8.6.13",
        "tomli==2.0.1",
        "tqdm==4.66.1",
        "typing-extensions==4.9.0",
        "typing_extensions==4.9.0",
        "tzdata==2023d",
        "umap-learn==0.5.5",
        "unicodedata2==15.1.0",
        "wheel==0.42.0",
        "xz==5.2.6",
        "zipp==3.17.0",
        "zlib==1.2.13",
        "zstd==1.5.5")
} else if (basilisk.utils::isMacOSXArm()) {
    .sketchR_dependencies <- c(
        "anndata==0.10.5.post1",
        "array-api-compat==1.4.1",
        "blosc==1.21.5",
        "bottleneck==1.3.7",
        "brotli==1.1.0",
        "brotli-bin==1.1.0",
        "bzip2==1.0.8",
        "c-ares==1.26.0",
        "ca-certificates==2023.11.17",
        "cached-property==1.5.2",
        "cached_property==1.5.2",
        "certifi==2023.11.17",
        "colorama==0.4.6",
        "contourpy==1.2.0",
        "curl==8.5.0",
        "cycler==0.12.1",
        "dunamai==1.19.0",
        "exceptiongroup==1.2.0",
        "fonttools==4.47.2",
        "freetype==2.12.1",
        "get_version==3.5.5",
        "gettext==0.21.1",
        "git==2.43.0",
        "h5py==3.8.0",
        "hdf5==1.14.0",
        "icu==73.2",
        "importlib-metadata==7.0.1",
        "importlib_metadata==7.0.1",
        "joblib==1.1.0",
        "jpeg==9e",
        "kiwisolver==1.4.5",
        "krb5==1.21.2",
        "lcms2==2.12",
        "legacy-api-wrap==1.2",
        "lerc==3.0",
        "libaec==1.1.2",
        "libblas==3.9.0",
        "libbrotlicommon==1.1.0",
        "libbrotlidec==1.1.0",
        "libbrotlienc==1.1.0",
        "libcblas==3.9.0",
        "libcurl==8.5.0",
        "libcxx==16.0.6",
        "libdeflate==1.10",
        "libedit==3.1.20191231",
        "libev==4.33",
        "libexpat==2.5.0",
        "libffi==3.4.2",
        "libgfortran==5.0.0",
        "libgfortran5==13.2.0",
        "libhwloc==2.9.3",
        "libiconv==1.17",
        "liblapack==3.9.0",
        "libllvm14==14.0.6",
        "libnghttp2==1.58.0",
        "libopenblas==0.3.25",
        "libpng==1.6.42",
        "libsqlite==3.44.2",
        "libssh2==1.11.0",
        "libtiff==4.3.0",
        "libwebp-base==1.3.2",
        "libxml2==2.12.4",
        "libzlib==1.2.13",
        "llvm-openmp==17.0.6",
        "llvmlite==0.40.1",
        "lz4-c==1.9.4",
        "matplotlib-base==3.6.3",
        "munkres==1.0.7",
        "natsort==8.4.0",
        "ncurses==6.4",
        "networkx==3.2",
        "numba==0.57.1",
        "numexpr==2.8.3",
        "numpy==1.21.5",
        "olefile==0.47",
        "openjpeg==2.5.0",
        "openssl==3.2.1",
        "packaging==23.2",
        "pandas==1.3.5",
        "patsy==0.5.6",
        "pcre2==10.42",
        "perl==5.32.1",
        "pillow==8.4.0",
        "pip==23.3.2",
        "pynndescent==0.5.11",
        "pyparsing==3.1.1",
        "pytables==3.7.0",
        "python==3.9.18",
        "python-dateutil==2.8.2",
        "python_abi==3.9",
        "pytz==2023.4",
        "readline==8.2",
        "scanpy==1.7.2",
        "scikit-learn==1.0.2",
        "scipy==1.7.3",
        "seaborn==0.13.2",
        "seaborn-base==0.13.2",
        "setuptools==69.0.3",
        "setuptools-scm==8.0.4",
        "setuptools_scm==8.0.4",
        "sinfo==0.3.1",
        "six==1.16.0",
        "snappy==1.1.10",
        "statsmodels==0.13.5",
        "stdlib-list==0.10.0",
        "tbb==2021.11.0",
        "threadpoolctl==3.0.0",
        "tk==8.6.13",
        "tomli==2.0.1",
        "tqdm==4.66.1",
        "typing-extensions==4.9.0",
        "typing_extensions==4.9.0",
        "tzdata==2023d",
        "umap-learn==0.5.5",
        "unicodedata2==15.1.0",
        "wheel==0.42.0",
        "xz==5.2.6",
        "zipp==3.17.0",
        "zlib==1.2.13",
        "zstd==1.5.5")
} else if (basilisk.utils::isMacOSX()) {
    .sketchR_dependencies <- c(
        "anndata==0.10.5.post1",
        "array-api-compat==1.4.1",
        "blosc==1.21.5",
        "bottleneck==1.3.7",
        "brotli==1.1.0",
        "brotli-bin==1.1.0",
        "bzip2==1.0.8",
        "c-ares==1.26.0",
        "ca-certificates==2023.11.17",
        "cached-property==1.5.2",
        "cached_property==1.5.2",
        "certifi==2023.11.17",
        "colorama==0.4.6",
        "contourpy==1.2.0",
        "curl==8.5.0",
        "cycler==0.12.1",
        "dunamai==1.19.0",
        "exceptiongroup==1.2.0",
        "fonttools==4.47.2",
        "freetype==2.12.1",
        "get_version==3.5.5",
        "gettext==0.21.1",
        "git==2.43.0",
        "h5py==3.8.0",
        "hdf5==1.14.0",
        "icu==73.2",
        "importlib-metadata==7.0.1",
        "importlib_metadata==7.0.1",
        "joblib==1.1.0",
        "jpeg==9e",
        "kiwisolver==1.4.5",
        "krb5==1.21.2",
        "lcms2==2.12",
        "legacy-api-wrap==1.2",
        "lerc==3.0",
        "libaec==1.1.2",
        "libblas==3.9.0",
        "libbrotlicommon==1.1.0",
        "libbrotlidec==1.1.0",
        "libbrotlienc==1.1.0",
        "libcblas==3.9.0",
        "libcurl==8.5.0",
        "libcxx==16.0.6",
        "libdeflate==1.10",
        "libedit==3.1.20191231",
        "libev==4.33",
        "libexpat==2.5.0",
        "libffi==3.4.2",
        "libgfortran==5.0.0",
        "libgfortran5==13.2.0",
        "libhwloc==2.9.3",
        "libiconv==1.17",
        "liblapack==3.9.0",
        "libllvm14==14.0.6",
        "libnghttp2==1.58.0",
        "libopenblas==0.3.25",
        "libpng==1.6.42",
        "libsqlite==3.44.2",
        "libssh2==1.11.0",
        "libtiff==4.3.0",
        "libwebp-base==1.3.2",
        "libxml2==2.12.4",
        "libzlib==1.2.13",
        "llvm-openmp==17.0.6",
        "llvmlite==0.40.1",
        "lz4-c==1.9.4",
        "matplotlib-base==3.6.3",
        "munkres==1.0.7",
        "natsort==8.4.0",
        "ncurses==6.4",
        "networkx==3.2",
        "numba==0.57.1",
        "numexpr==2.8.3",
        "numpy==1.21.5",
        "olefile==0.47",
        "openjpeg==2.5.0",
        "openssl==3.2.1",
        "packaging==23.2",
        "pandas==1.3.5",
        "patsy==0.5.6",
        "pcre2==10.42",
        "perl==5.32.1",
        "pillow==8.4.0",
        "pip==23.3.2",
        "pynndescent==0.5.11",
        "pyparsing==3.1.1",
        "pytables==3.7.0",
        "python==3.9.12",
        "python-dateutil==2.8.2",
        "python_abi==3.9",
        "pytz==2023.4",
        "readline==8.2",
        "scanpy==1.7.2",
        "scikit-learn==1.0.2",
        "scipy==1.7.3",
        "seaborn==0.13.2",
        "seaborn-base==0.13.2",
        "setuptools==69.0.3",
        "setuptools-scm==8.0.4",
        "setuptools_scm==8.0.4",
        "sinfo==0.3.1",
        "six==1.16.0",
        "snappy==1.1.10",
        "sqlite==3.44.2",
        "statsmodels==0.13.5",
        "stdlib-list==0.10.0",
        "tbb==2021.11.0",
        "threadpoolctl==3.0.0",
        "tk==8.6.13",
        "tomli==2.0.1",
        "tqdm==4.66.1",
        "typing-extensions==4.9.0",
        "typing_extensions==4.9.0",
        "tzdata==2023d",
        "umap-learn==0.5.5",
        "unicodedata2==15.1.0",
        "wheel==0.42.0",
        "xz==5.2.6",
        "zipp==3.17.0",
        "zlib==1.2.13",
        "zstd==1.5.5")
} else if (basilisk.utils::isWindows()) {
    .sketchR_dependencies <- c(
        "anndata==0.10.5.post1",
        "array-api-compat==1.4.1",
        "blosc==1.21.5",
        "bottleneck==1.3.7",
        "brotli==1.1.0",
        "brotli-bin==1.1.0",
        "bzip2==1.0.8",
        "ca-certificates==2023.11.17",
        "cached-property==1.5.2",
        "cached_property==1.5.2",
        "certifi==2023.11.17",
        "colorama==0.4.6",
        "contourpy==1.2.0",
        "cycler==0.12.1",
        "dunamai==1.19.0",
        "exceptiongroup==1.2.0",
        "fonttools==4.47.2",
        "freetype==2.12.1",
        "get_version==3.5.5",
        "git==2.43.0",
        "h5py==3.8.0",
        "hdf5==1.14.0",
        "importlib-metadata==7.0.1",
        "importlib_metadata==7.0.1",
        "intel-openmp==2024.0.0",
        "joblib==1.1.0",
        "jpeg==9e",
        "kiwisolver==1.4.5",
        "krb5==1.21.2",
        "lcms2==2.12",
        "legacy-api-wrap==1.2",
        "lerc==3.0",
        "libaec==1.1.2",
        "libblas==3.9.0",
        "libbrotlicommon==1.1.0",
        "libbrotlidec==1.1.0",
        "libbrotlienc==1.1.0",
        "libcblas==3.9.0",
        "libcurl==8.5.0",
        "libdeflate==1.10",
        "libffi==3.4.2",
        "libhwloc==2.9.3",
        "libiconv==1.17",
        "liblapack==3.9.0",
        "libpng==1.6.42",
        "libsqlite==3.44.2",
        "libssh2==1.11.0",
        "libtiff==4.3.0",
        "libwebp==1.3.2",
        "libwebp-base==1.3.2",
        "libxcb==1.13",
        "libxml2==2.12.4",
        "libzlib==1.2.13",
        "llvmlite==0.40.1",
        "lz4-c==1.9.4",
        "m2w64-gcc-libgfortran==5.3.0",
        "m2w64-gcc-libs==5.3.0",
        "m2w64-gcc-libs-core==5.3.0",
        "m2w64-gmp==6.1.0",
        "m2w64-libwinpthread-git==5.0.0.4634.697f757",
        "matplotlib-base==3.6.3",
        "mkl==2024.0.0",
        "msys2-conda-epoch==20160418",
        "munkres==1.0.7",
        "natsort==8.4.0",
        "networkx==3.2",
        "numba==0.57.1",
        "numexpr==2.7.3",
        "numpy==1.21.5",
        "openjpeg==2.5.0",
        "openssl==3.2.1",
        "packaging==23.2",
        "pandas==1.3.5",
        "patsy==0.5.6",
        "pillow==9.1.1",
        "pip==23.3.2",
        "pthread-stubs==0.4",
        "pthreads-win32==2.9.1",
        "pynndescent==0.5.11",
        "pyparsing==3.1.1",
        "pytables==3.7.0",
        "python==3.9.12",
        "python-dateutil==2.8.2",
        "python_abi==3.9",
        "pytz==2023.4",
        "scanpy==1.7.2",
        "scikit-learn==1.0.2",
        "scipy==1.7.3",
        "seaborn==0.13.2",
        "seaborn-base==0.13.2",
        "setuptools==69.0.3",
        "setuptools-scm==8.0.4",
        "setuptools_scm==8.0.4",
        "sinfo==0.3.1",
        "six==1.16.0",
        "snappy==1.1.10",
        "sqlite==3.44.2",
        "statsmodels==0.13.5",
        "stdlib-list==0.10.0",
        "tbb==2021.11.0",
        "threadpoolctl==3.0.0",
        "tk==8.6.13",
        "tomli==2.0.1",
        "tqdm==4.66.1",
        "typing-extensions==4.9.0",
        "typing_extensions==4.9.0",
        "tzdata==2023d",
        "ucrt==10.0.22621.0",
        "umap-learn==0.5.5",
        "unicodedata2==15.1.0",
        "vc==14.3",
        "vc14_runtime==14.38.33130",
        "vs2015_runtime==14.38.33130",
        "wheel==0.42.0",
        "xorg-libxau==1.0.11",
        "xorg-libxdmcp==1.1.3",
        "xz==5.2.6",
        "zipp==3.17.0",
        "zlib==1.2.13",
        "zstd==1.5.5")
}

universalenv <- BasiliskEnvironment(
    envname = "universal", pkgname = "sketchR",
    packages = .sketchR_dependencies,
    channels = c("bioconda", "conda-forge"),
    pip = c("fbpca==1.0", "geosketch==1.2", "scsampler==1.0.2")
)

